diff a/PEA/.gitignore b/PEA/.gitignore
--- /dev/null
+++ b/PEA/.gitignore
@@ -0,0 +1,2 @@
+*.class
+*.log
diff a/PEA/BadGraphVolatile.java b/PEA/BadGraphVolatile.java
--- /dev/null
+++ b/PEA/BadGraphVolatile.java
@@ -0,0 +1,24 @@
+class BadGraphVolatile {
+    // use volatile to force c2 to load it again
+    volatile int value;
+
+    BadGraphVolatile(int value) {
+        this.value = value;
+    }
+
+    void blackhole(int field) {
+        assert field  == 42 :" wrong answer";
+    }
+
+    public static void foo(int value) {
+        var x = new BadGraphVolatile(value);
+        x.blackhole(x.value);
+        return;
+    }
+
+    public static void main(String[] args)  {
+        for (int i = 0; i < 30_000; ++i) {
+            foo(42);
+        }
+    }
+}
diff a/PEA/CompositeObjects.java b/PEA/CompositeObjects.java
--- /dev/null
+++ b/PEA/CompositeObjects.java
@@ -0,0 +1,24 @@
+class CompositeObjects {
+    static class Node {
+       public Node _next;
+       public Node() {}
+    }
+
+    static Object _global;
+
+    public static void test() {
+        var a = new Node();
+        var b = new Node();
+
+        a._next = b; b._next = a;
+        blackhole(a); // materialize a here.
+    }
+    public static void blackhole(Object o) {
+        _global = o;
+    }
+    public static void main(String[] args ) {
+        for (int i=0; i < 100_000; ++i) {
+            test();
+        }
+    }
+}
diff a/PEA/CountUppercase.java b/PEA/CountUppercase.java
--- /dev/null
+++ b/PEA/CountUppercase.java
@@ -0,0 +1,20 @@
+// https://www.graalvm.org/22.1/examples/java-performance-examples/#streams-api-example
+public class CountUppercase {
+    static final int ITERATIONS = Math.max(Integer.getInteger("iterations", 1), 1);
+    public static void main(String[] args) {
+        String sentence = String.join(" ", args);
+        for (int iter = 0; iter < ITERATIONS; iter++) {
+            if (ITERATIONS != 1) System.out.println("-- iteration " + (iter + 1) + " --");
+            long total = 0, start = System.currentTimeMillis(), last = start;
+            for (int i = 1; i < 10_000_000; i++) {
+                total += sentence.chars().filter(Character::isUpperCase).count();
+                if (i % 1_000_000 == 0) {
+                    long now = System.currentTimeMillis();
+                    System.out.printf("%d (%d ms)%n", i / 1_000_000, now - last);
+                    last = now;
+                }
+            }
+            System.out.printf("total: %d (%d ms)%n", total, System.currentTimeMillis() - start);
+        }
+    }
+}
diff a/PEA/CrazyException.java b/PEA/CrazyException.java
--- /dev/null
+++ b/PEA/CrazyException.java
@@ -0,0 +1,23 @@
+class CrazyException {
+    void blackhole() {}
+    public static Object foo(boolean cond) {
+        var x = new CrazyException();
+        for (int i=0; i< 100; ++i) {
+          if (cond)  {
+              try {
+                  x.blackhole(); // not inline. escape here.
+              } finally {        // hidden catch(Throwable) is here!
+                  close();
+              }
+          }
+        }
+        return x;
+    }
+
+    public static void close() {}
+    public static void main(String[] args)  {
+        for (int i = 0; i < 20_000; ++i) {
+            CrazyException.foo(0 == ( i& 0xf));
+        }
+    }
+}
diff a/PEA/EscapeInInitializer.java b/PEA/EscapeInInitializer.java
--- /dev/null
+++ b/PEA/EscapeInInitializer.java
@@ -0,0 +1,64 @@
+class EscapeInInitializer {
+    private final int foo;
+    private final int bar;
+    private static EscapeInInitializer cache;
+
+    EscapeInInitializer() {
+        this.foo = 1;   // put a final field, set_alloc_with_final(obj)
+        cache = this;   // materialize this here.
+        this.bar = 2;   // put a final field again, set_alloc_with_final(obj)
+    }
+
+    EscapeInInitializer(int i) {
+        this.foo = 1;   // put a final field, set_alloc_with_final(obj)
+        this.bar = the_answer(); // invocation, either inline or not line may trigger materialization.
+    }
+
+    EscapeInInitializer(boolean cond) {
+        this.foo = 1;   // put a final field, set_alloc_with_final(obj)
+        this.bar = 2;
+        if  (cond) {
+            cache = this;   // materialize this here.
+        }
+        // we need to merge 'this' here, and then emit the trailing barrier for the phi.
+    }
+
+    int the_answer() { // of life, the universe and everything...
+        cache = this;  // materialize 'this' here
+        return 42;
+    }
+
+    static class Scope {
+      public int kind;
+      final Scope parent;
+      final Scope compilationUnitScope;
+
+      // https://github.com/testforstephen/eclipse.jdt.core/blob/c74a21fabed6931812aac1d1cc3b5b09690e8c96/org.eclipse.jdt.core/compiler/org/eclipse/jdt/internal/compiler/lookup/Scope.java#L159C86-L159C106
+      public Scope(int kind, Scope parent) {
+        this.kind = kind;
+        this.parent = parent;
+        this.compilationUnitScope = (parent == null ? this : parent.compilationUnitScope());
+      }
+
+      public Scope compilationUnitScope() {
+        return new Scope(0, null);
+      }
+    }
+
+    static void test(int i) {
+        var kase = new EscapeInInitializer();
+        var kase2 = new EscapeInInitializer(i);
+        var kase3 = new EscapeInInitializer(0 == (i % 100));
+    }
+
+    static void test2(int i) {
+        Scope parent = new Scope(1, null);
+        var kase = new Scope(i, 0 == (i % 100) ? null : parent);
+    }
+    public static void main(String[] args) {
+        for (int i = 0; i < 30_000; ++i) {
+            test(i);
+            test2(i);
+        }
+    }
+}
diff a/PEA/Example1.java b/PEA/Example1.java
--- /dev/null
+++ b/PEA/Example1.java
@@ -0,0 +1,29 @@
+class Example1 {
+    private Object _cache;
+    public void test(boolean cond) {
+        Object x = new Object();
+
+        if (cond) {
+            _cache = x;
+        }
+    }
+
+    public Object test2(boolean cond) {
+        Object x = new Object();
+
+        if (cond) {
+            _cache = x;
+        }
+
+        return cond ? null: x;
+    }
+
+    public static void main(String[] args)  {
+        Example1 kase = new Example1();
+
+        for (int i = 0; i < 1_000_000; ++i) {
+            kase.test(0 == (i& 0xf));
+            kase.test2(0 == (i& 0xf));
+        }
+    }
+}
diff a/PEA/Example1_ivanov.java b/PEA/Example1_ivanov.java
--- /dev/null
+++ b/PEA/Example1_ivanov.java
@@ -0,0 +1,36 @@
+// -Xcomp -Xms16M -Xmx16M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:CompileOnly='Example1.ivanov' -XX:CompileCommand=dontinline,Example1.blackhole
+class Example1_ivanov {
+    // Ivanov suggest to make this happen first.
+    // we don't need to create JVMState for the cloning Allocate.
+    public void ivanov(boolean cond) {
+        Object x = new Object();
+
+        if (cond) {
+            blackhole(x);
+        }
+    }
+
+    static void blackhole(Object x) {}
+
+    public void test1(boolean cond) {
+        ivanov(cond);
+    }
+
+    public static void main(String[] args)  {
+        Example1_ivanov kase = new Example1_ivanov();
+        // Epsilon Test:
+        // By setting the maximal heap and use EpsilonGC, let's see how long and how many iterations the program can sustain.
+        // if PEA manages to reduce allocation rate, we expect the program to stay longer.
+        // Roman commented it with a resonable doubt: "or your code slow down the program..."
+        // That's why I suggest to observe iterations. It turns out not trivial because inner OOME will implode hotspot. We don't have a chance to execute the final statement...
+        long iterations = 0;
+        try {
+            while (true) {
+                kase.test1(0 == (iterations & 0xf));
+                iterations++;
+            }
+        } finally {
+            System.err.println("Epsilon Test: " + iterations);
+        }
+    }
+}
diff a/PEA/Example2.java b/PEA/Example2.java
--- /dev/null
+++ b/PEA/Example2.java
@@ -0,0 +1,34 @@
+// -Xcomp -Xms16M -Xmx16M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:CompileOnly='Example2.foo' -XX:CompileCommand=dontinline,Example2.blackhole
+class Example2 {
+    private Object _cache;
+    public Object foo(boolean cond) {
+        Object x = new Object();
+        
+        blackhole();
+
+        if (cond) {
+            _cache = x;
+        }
+        return x;
+    }
+
+    public static void blackhole() {}
+    
+    public static void main(String[] args)  {
+        Example2 kase = new Example2();
+        // Epsilon Test:
+        // By setting the maximal heap and use EpsilonGC, let's see how long and how many iterations the program can sustain.
+        // if PEA manages to reduce allocation rate, we expect the program to stay longer.
+        // Roman commented it with a resonable doubt: "or your code slow down the program..."
+        // That's why I suggest to observe iterations. It turns out not trivial because inner OOME will implode hotspot. We don't have a chance to execute the final statement...
+        long iterations = 0;
+        try {
+            while (true) {
+                kase.foo(0 == (iterations & 0xf));
+                iterations++;
+            }
+        } finally {
+            System.err.println("Epsilon Test: " + iterations);
+        }
+    }
+}
diff a/PEA/Example2_1.java b/PEA/Example2_1.java
--- /dev/null
+++ b/PEA/Example2_1.java
@@ -0,0 +1,50 @@
+// -Xcomp -Xms16M -Xmx16M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:CompileOnly='Example2.foo' -XX:CompileCommand=dontinline,Example2.blackhole
+class Example2_1 {
+    int value  = 0;
+
+    public static Example2_1 foo(boolean cond) {
+        var x = new Example2_1();
+        
+        if (cond) {
+            x.value++;
+        } else {
+            x.value += 2;
+        }
+        return x;
+    }
+
+    public static int foo2(boolean cond) {
+        var x = new Example2_1();
+        
+        if (cond) {
+            x.value++;
+        } else {
+            x.value += 2;
+        }
+        return x.value;
+    }
+
+
+    public static void blackhole() {}
+    
+    public static void main(String[] args)  {
+        long iterations = 0;
+        try {
+            while (true) {
+                boolean cond = 0 == (iterations & 0xf);
+                Example2_1 obj = foo(cond);
+                int expected = cond ? 1 : 2; 
+                if (obj.value != expected) {
+                    throw new RuntimeException("wrong answer");
+                }
+                int val = foo2(cond);
+                if (val != expected) {
+                    throw new RuntimeException("wrong answer");
+                }
+                iterations++;
+            }
+        } finally {
+            System.err.println("Epsilon Test: " + iterations);
+        }
+    }
+}
diff a/PEA/Example2_merykitty.java b/PEA/Example2_merykitty.java
--- /dev/null
+++ b/PEA/Example2_merykitty.java
@@ -0,0 +1,38 @@
+// -Xcomp -Xms16M -Xmx16M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:CompileOnly='Example2_merykitty.foo' -XX:CompileCommand=dontinline,Example2_merykitty.blackhole
+class Example2_merykitty {
+    private static Object _cache1;
+    private static Object _cache2;
+
+    public void foo(boolean cond1, boolean cond2) {
+        Object x = new Object();
+    
+        blackhole();
+    
+        if (cond1) {
+            _cache1 = x;
+        }
+    
+        blackhole();
+    
+        if (cond2) {
+            _cache2 = x;
+        }
+    }
+
+    public static void blackhole() {}
+    
+    public static void main(String[] args)  {
+        Example2_merykitty kase = new Example2_merykitty();
+        long iterations = 0;
+        try {
+            while (true) {
+                boolean cond = 0 == (iterations & 0xf);
+                kase.foo(cond, cond);
+                assert Example2_merykitty._cache1 == Example2_merykitty._cache2 :"check";
+                iterations++;
+            }
+        } finally {
+            System.err.println("Epsilon Test: " + iterations);
+        }
+    }
+}
diff a/PEA/Example2b.java b/PEA/Example2b.java
--- /dev/null
+++ b/PEA/Example2b.java
@@ -0,0 +1,66 @@
+// java -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:CompileCommand='compileonly,Example2b::foo*' -Xlog:gc -XX:+DoPartialEscapeAnalysis -XX:+PrintEscapeAnalysis -XX:+PrintEliminateAllocations -XX:-PrintCompilation -XX:CompileCommand=quiet  Example2b
+class Example2b {
+    public String _cache;
+
+    public String foo(boolean cond) {
+        String x = null;
+
+        if (cond) {
+            x = new String("hello");
+        }
+
+        return x;
+    }
+    public String foo2(boolean cond) {
+        String x = null;
+
+        if (cond) {
+            x = new String("hello");
+            _cache = x;       // object 'x' escapes
+        }
+
+        return x;
+    }
+
+    public String foo3(String str, boolean cond) {
+        if (str == null) {
+            str = new String("hello");
+        }
+        if (cond) {
+            _cache = str;
+        }
+        return str;
+    }
+    public static void main(String[] args)  {
+        Example2b kase = new Example2b();
+        int iterations = 0;
+        try {
+            while (true) {
+                boolean cond = 0 == (iterations & 0xf);
+                String s = kase.foo(cond);
+                if (s != null && !s.equals("hello")) {
+                    throw new RuntimeException("e");
+                }
+
+                kase.foo2(cond);
+                if (kase._cache != null && !kase._cache.equals("hello")) {
+                    throw new RuntimeException("e2");
+                }
+
+                if (0 == (iterations % 2)) {
+                    s = kase.foo3(null, cond);
+                } else {
+                    s= kase.foo3(kase._cache, cond);
+                }
+
+                if (s != null && !s.equals("hello")) {
+                    throw new RuntimeException("e3");
+                }
+
+                iterations++;
+            }
+        } finally {
+            System.err.println("Epsilon Test: " + iterations);
+        }
+    }
+}
diff a/PEA/Example3.java b/PEA/Example3.java
--- /dev/null
+++ b/PEA/Example3.java
@@ -0,0 +1,63 @@
+//  from ResourceScopeCloseMin.java
+//  https://bugs.openjdk.org/browse/JDK-8267532
+import java.util.ArrayList;
+import java.util.List;
+import java.util.concurrent.TimeUnit;
+
+public class Example3 {
+
+    Runnable dummy = () -> {};
+
+    static class ConfinedScope {
+        final Thread owner;
+        boolean closed;
+        final List<Runnable> resources = new ArrayList<>();
+        //int [] weight = new int[1024];
+        //final Runnable[] resources = new Runnable[1];
+
+        private void checkState() {
+            if (closed) {
+                throw new AssertionError("Closed");
+            } else if (owner != Thread.currentThread()) {
+                throw new AssertionError("Wrong thread");
+            }
+        }
+
+        ConfinedScope() {
+            this.owner = Thread.currentThread();
+        }
+
+        void addCloseAction(Runnable runnable) {
+            checkState();
+            resources.add(runnable);
+            //resources[0] = runnable;
+        }
+
+        public void close() {
+            checkState();
+            closed = true;
+            for (Runnable r : resources) {
+                r.run();
+            }
+        }
+    }
+
+    public void confined_close() {
+        ConfinedScope scope = new ConfinedScope();
+        try { // simulate TWR
+            scope.addCloseAction(dummy);
+            scope.close();
+        } catch (RuntimeException ex) {
+            scope.close();
+            throw ex;
+        }
+    }
+
+    public static void main(String[] args) {
+	    var kase = new Example3();
+	
+        while (true) {
+            kase.confined_close();
+        }
+    }
+}
diff a/PEA/Example3_1.java b/PEA/Example3_1.java
--- /dev/null
+++ b/PEA/Example3_1.java
@@ -0,0 +1,38 @@
+// java -Xms16M -Xmx16M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:-UseTLAB -XX:CompileOnly='Example3_1.foo' -XX:+DoPartialEscapeAnalysis Example3_1
+import java.util.ArrayList; 
+
+class Example3_1 {
+    public ArrayList<Integer> _cache;
+    public void foo(boolean cond) {
+        ArrayList<Integer> x = new ArrayList<Integer>();
+
+        if (cond) {
+            _cache = x;
+        }
+    }
+
+    public void test1(boolean cond) {
+        foo(cond);
+    }
+
+    public static void main(String[] args)  {
+        Example3_1 kase = new Example3_1();
+        // Epsilon Test:
+        // By setting the maximal heap and use EpsilonGC, let's see how long and how many iterations the program can sustain.
+        // if PEA manages to reduce allocation rate, we expect the program to stay longer.
+        // Roman commented it with a resonable doubt: "or your code slow down the program..."
+        // That's why I suggest to observe iterations. It turns out not trivial because inner OOME will implode hotspot. We don't have a chance to execute the final statement...
+        long iterations = 0;
+        try {
+            while (true) {
+                kase.test1(0 == (iterations & 0xf));
+                if (kase._cache != null) {
+                    kase._cache.add(1);
+                }
+                iterations++;
+            }
+        } finally {
+            System.err.println("Epsilon Test: " + iterations);
+        }
+    }
+}
diff a/PEA/Example3_2.java b/PEA/Example3_2.java
--- /dev/null
+++ b/PEA/Example3_2.java
@@ -0,0 +1,35 @@
+import java.util.*;
+
+class Example3_2 {
+    //public static Integer zero = Integer.valueOf(0);
+
+    void bar(boolean cond, ArrayList<Integer> L) {
+        if(cond) {
+            L.add(0);
+        }
+    }
+
+    public void foo(boolean cond) {
+        var x = new ArrayList<Integer>();
+        bar(cond, x);
+        return;
+    }
+
+    public static void main(String[] args)  {
+        var kase = new Example3_2();
+        // Epsilon Test:
+        // By setting the maximal heap and use EpsilonGC, let's see how long and how many iterations the program can sustain.
+        // if PEA manages to reduce allocation rate, we expect the program to stay longer.
+        // Roman commented it with a resonable doubt: "or your code slow down the program..."
+        // That's why I suggest to observe iterations. It turns out not trivial because inner OOME will implode hotspot. We don't have a chance to execute the final statement...
+        long iterations = 0;
+        try {
+            while (true) {
+                kase.foo(0 == (iterations & 0xf));
+                iterations++;
+            }
+        } finally {
+            System.err.println("Epsilon Test: " + iterations);
+        }
+    }
+}
diff a/PEA/GetFieldIsAlias.java b/PEA/GetFieldIsAlias.java
--- /dev/null
+++ b/PEA/GetFieldIsAlias.java
@@ -0,0 +1,31 @@
+// inspired by this code snippet:
+// https://github.com/openjdk/jdk/blob/42758cb889a5cf1d7f4c4b468a383b218baa1b27/src/jdk.compiler/share/classes/com/sun/tools/javac/code/Symbol.java#L1318
+class GetFieldIsAlias {
+    static class Type {
+        private int value;
+        public GetFieldIsAlias parent;
+
+        public Type(int value, GetFieldIsAlias parent) {
+            this.value = value;
+            this.parent = parent;
+        }
+    }
+
+    public Type type;
+    public GetFieldIsAlias() {
+        this.type = new Type(42, null);
+        // 'this.type' is supposed to be the fix pattern: AddP-LoadN-DecodeN-CastPP.
+        // We need to ensure this.type is alias with the object just created, or PEA assumes that this.type is 'a global variable'
+        // and we have to materialize 'this'.
+        this.type.parent = this;
+    }
+
+    public static void main(String[] args) {
+        for (int i = 0; i< 200_000; ++i) {
+            var obj = new GetFieldIsAlias();
+            if (obj.type.parent != obj) {
+                throw new RuntimeException("wrong answer");
+            }
+        }
+    }
+}
diff a/PEA/LoadSelfIntoField.java b/PEA/LoadSelfIntoField.java
--- /dev/null
+++ b/PEA/LoadSelfIntoField.java
@@ -0,0 +1,37 @@
+class LoadSelfIntoField {
+    // Test that PEA handles loading self into a field correctly.
+    // This test is a smaller reproducer of Test6843752.
+    static class Item {
+        public Item    next;
+        public Item    prev;
+    }
+    Item list = null;
+
+    private Item test(boolean cond) {
+        Item item = new Item();
+        Item head = list;
+        if (cond) {
+            item.next = item;
+            item.prev = item;
+            list = item;
+            // Confirm we correctly materialize setting object's field to self.
+            assert item == item.next;
+            assert item == item.prev;
+        } else {
+            item.next = head;
+            item.prev = head.prev;
+            head.prev.next = item;
+            head.prev = item;
+        }
+        return item;
+    }
+
+    public static void main(String[] args)  {
+        LoadSelfIntoField obj = new LoadSelfIntoField();
+        long iterations = 0;
+        while (iterations <= 20000) {
+            obj.test(0 == (iterations & 0xf));
+            iterations++;
+        }
+    }
+}
diff a/PEA/Makefile b/PEA/Makefile
--- /dev/null
+++ b/PEA/Makefile
@@ -0,0 +1,61 @@
+.DEFAULT_GOAL := all
+
+JAVA_HOME ?= $(abspath ../build/linux-x86_64-server-fastdebug/jdk)
+export PATH := ${JAVA_HOME}/bin:$(PATH)
+
+CTW_DIR := $(abspath ../test/hotspot/jtreg/testlibrary/ctw)
+CTW_DIST= ${CTW_DIR}/dist
+CTW_JAVA_OPTIONS := -XX:+CITime -XX:-TieredCompilation -XX:+UseTLAB -XX:+PrintCompilation -XX:+PrintOptoStatistics -XX:+UnlockExperimentalVMOptions -XX:+DoPartialEscapeAnalysis
+comma := ,
+empty :=
+space := $(empty) $(empty)
+# CTWRunner accepts arguments with commas instead of spaces
+CTW_RUNNER_JAVA_OPTIONS := $(subst $(space),$(comma),$(CTW_JAVA_OPTIONS))
+CONF ?= linux-x86_64-server-fastdebug
+JTREG_COMMON = JAVA_OPTIONS=-XX:+UnlockExperimentalVMOptions -XX:+DoPartialEscapeAnalysis
+JTREG_PARANOID=VM_OPTIONS=-ea -esa -XX:CompileThreshold=100
+
+set_jdk:
+	if [ -e ${JAVA_HOME} ]; then \
+		echo "choose ${JAVA_HOME}"; \
+		java -version; \
+	else \
+		echo "can't find valid jdk!"; \
+		exit 1; \
+	fi
+
+classes := $(patsubst %.java, %.class, $(wildcard *.java))
+
+%.class: %.java
+	javac --add-exports java.base/jdk.internal.misc=ALL-UNNAMED $<
+
+smoketest: set_jdk $(classes)
+	./auto.rb
+
+$(CTW_DIST):
+	${MAKE} -C ${CTW_DIR} all
+
+run-ctw: set_jdk ${CTW_DIST}
+	cd ${CTW_DIST}; \
+	JAVA_OPTIONS="-Dsun.hotspot.tools.ctwrunner.ctw_extra_args=${CTW_RUNNER_JAVA_OPTIONS}" JAVA_HOME=${JAVA_HOME} ./ctwrunner.sh modules:java.base
+
+run-ctw-no-inline: set_jdk ${CTW_DIST}
+	cd ${CTW_DIST}; \
+	JAVA_OPTIONS="${CTW_JAVA_OPTIONS} -XX:-Inline" JAVA_HOME=${JAVA_HOME} ./ctw.sh modules:java.base
+
+bootstrap-version: set_jdk
+	java -Xcomp -XX:-TieredCompilation -XX:CICompilerCount=1 -Xbatch -XX:+UnlockExperimentalVMOptions -XX:+DoPartialEscapeAnalysis -version
+
+hotspot-tier1:
+	cd ..; make test TEST="hotspot:tier1" CONF=${CONF} JREG="${JTREG_COMMON}"
+
+hotspot-tier1-paranoid:
+	cd ..; make test TEST="hotspot:tier1" CONF=${CONF} JTREG="${JTREG_COMMON};${JTREG_PARANOID}"
+
+hotspot-tier2:
+	cd ..; make test TEST="hotspot:tier2" CONF=${CONF} JREG="${JTREG_COMMON}"
+
+all: smoketest bootstrap-version
+
+clean:
+	rm *.class *.log
diff a/PEA/MatInMonitor.java b/PEA/MatInMonitor.java
--- /dev/null
+++ b/PEA/MatInMonitor.java
@@ -0,0 +1,68 @@
+class MatInMonitor {
+    private Object _cache;
+    private boolean _odd;
+
+    public void test() {
+        Object x = new Object();
+        synchronized (x) {
+            _cache = x;
+        }
+    }
+
+    public void test2() {
+        Object x = new Object();
+        Object y = new Object();
+        synchronized (x) {
+        synchronized (y) {
+            _cache = x; // steal the monitor of x, which is not the top of stack.
+        }}
+    }
+
+    public void test3() {
+        Object x = new Object();
+        synchronized (x) {
+            if (_odd) {
+                _cache = x;
+            }
+        }
+    }
+    // c2 doesn't support this nesting form. GeneratePairingInfo regards it as 'unbalanced'.
+    public void testNested() {
+        Object x = new Object();
+        synchronized (x) {
+        synchronized (x) {
+        synchronized (x) {
+            _cache = x;
+        }}}
+    }
+
+    synchronized void bar() {
+        if (_odd) {
+            _cache = this; // escaping
+        }
+    }
+
+    synchronized void foo() { bar(); }
+
+    // Perfectly fine in C2. it is also a nesting lock after inlining.
+    // it passes GeneratePairingInfo becasue it is intra-procedural.
+    public void testNested2() {
+        synchronized(this) {
+            foo();
+        }
+    }
+
+    public static void main(String[] args)  {
+        MatInMonitor kase = new MatInMonitor();
+
+        for (int i = 0; i < 10_000; ++i) {
+            kase._odd = 0 == (i& 0xf);
+            kase.test();
+            kase.test2();
+            kase.test3();
+
+            kase.testNested();
+            kase.testNested2();
+        }
+    }
+}
diff a/PEA/MaterializeMember.java b/PEA/MaterializeMember.java
--- /dev/null
+++ b/PEA/MaterializeMember.java
@@ -0,0 +1,42 @@
+import java.util.*;
+
+class MaterializeMember {
+    // inspired by TestNG-7.3.0
+    // https://github.com/testng-team/testng/blob/9ae7d3d9d19e5aa51e9610549c72e883718e82e5/src/main/java/org/testng/internal/reflect/ReflectionRecipes.java#L369C56-L369C80
+    private static class ListBackedImmutableQueue<T> {
+        private final List<T> backingList;
+
+        ListBackedImmutableQueue(final T[] elements) {
+            backingList = new ArrayList<>(elements.length);
+            Collections.addAll(backingList, elements);
+        }
+
+        T poll() {
+            if (!backingList.isEmpty()) {
+                return backingList.remove(0);
+            }
+            throw new RuntimeException("Queue exhausted");
+        }
+    }
+
+    public void test() {
+        Integer[] parameters = new Integer[3];
+        for (int i = 0; i < parameters.length; ++i) {
+            parameters[i] = Integer.valueOf(i);
+        }
+        var queue = new ListBackedImmutableQueue<Integer>(parameters);
+        for (Integer p : parameters) {
+            Integer t = queue.poll();
+            if (!t.equals(p)) {
+                throw new RuntimeException("wrong result!");
+            }
+        }
+    }
+
+    public static void main(String[] args) {
+        MaterializeMember kase = new MaterializeMember();
+        for (int i = 0; i < 300_000; ++i) {
+            kase.test();
+        }
+    }
+}
